## -*-Tcl-*-
 # ==========================================================================
 #  Examples - a Help package for Alpha
 # 
 #  FILE: "WWW-Example.tcl"
 #                                    created: 10/17/2000 {02:18:43 pm} 
 #                                last update: 04/29/2002 {02:45:28 PM} 
 #  Description: 
 #  
 #  Script for the "WWW Example" in the Examples package.
 # 
 #  Author: Craig Barton Upright
 #  E-mail: <cupright@princeton.edu>
 #    mail: Princeton University, Department of Sociology
 #          Princeton, New Jersey 08544
 #     www: <http://www.princeton.edu/~cupright>
 #  
 # ==========================================================================
 ##

# The condition here really should be
# 
# if {[info tclversion] < 8.0 && [askyesno $wwwQuestion] == "yes"} {...}
# 
# but as of this writing 'httpCopy' will do a nasty freeze in Alpha8.0b1,
# so we only offer this for Alphatk and AlphaX.

set    wwwQuestion "Is an internet connection available? "
append wwwQuestion "(If not, a local html file will be rendered.)"

if {$tcl_platform(platform) != "macintosh" && [askyesno $wwwQuestion] == "yes"} {
    WWW::renderUrl "http://alphatcl.sourceforge.net/wikit/"
} else {
    WWW::renderFile [file join $HOME Help "HTML Help" HTMLmanual.html]

}

unset wwwQuestion
