## -*-Tcl-*-
 # ###################################################################
 #  HTML mode - tools for editing HTML documents
 # 
 #  FILE: "htmlContextualMenu.tcl"
 #                                    created: 01-10-27 22.04.47 
 #                                last update: 03/16/2002 {09:37:49 PM} 
 #  Author: Johan Linde
 #  E-mail: <alpha_www_tools@go.to>
 #     www: <http://go.to/alpha_www_tools>
 #  
 # Version: 3.1.6
 # 
 # Copyright 1996-2001 by Johan Linde
 #  
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
 # 
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 # 
 # ###################################################################
 ##

proc htmlContextualMenu.tcl {} {}

if {[info tclversion] < 8.0} {return}

namespace eval contextualMenu {}

newPref f EditTagItem 1 contextualMenuHTML
newPref f FollowLinkItem 1 contextualMenuHTML
newPref f htmlAttributesMenu 1 contextualMenuHTML

hook::register contextualPostBuildHook html::contextualPostBuild HTML
menu::buildProc "htmlAttributes" html::buildTagArgsMenu

proc html::buildTagArgsMenu {args} {
	global alpha::CMArgs
	variable CMattrmenuList
	set pos [lindex $alpha::CMArgs 0]
	set CMattrmenuList [html::GetAttributes $pos elem]
	if {[info exists elem] && [string index $elem 0] != "/"} {
		set CMattrmenuList [concat [list "('${elem}' Attributes:" "-"] $CMattrmenuList]
	} else {
		set CMattrmenuList ""
		status::msg ""
	} 
	return [list build $CMattrmenuList {html::CMTagArgsProc -m}]
}

proc html::CMTagArgsProc {menuName itemName} {
	global alpha::CMArgs
	goto [lindex [set alpha::CMArgs] 0]
	html::InsertAttributes $itemName
}

proc html::contextualPostBuild {args} {
	global contextualMenuHTMLmodeVars
	variable CMattrmenuList
	if {$contextualMenuHTMLmodeVars(EditTagItem)} {
		set tagpos [html::GetOpening [set pos [lindex $args 1]] 1]
		if {![llength $tagpos] || [pos::compare $pos < [lindex $tagpos 0]] || [pos::compare $pos > [lindex $tagpos 1]] || 
		[string index [lindex $tagpos 2] 0] == "/"} {
			enableMenuItem [lindex $args 0] EditTag off
		}
	}
	if {$contextualMenuHTMLmodeVars(FollowLinkItem) && [catch {html::FollowLink [lindex $args 1] 0}]} {
		enableMenuItem [lindex $args 0] FollowLink off
	}
	if {$contextualMenuHTMLmodeVars(htmlAttributesMenu) && ![llength $CMattrmenuList]} {
		enableMenuItem [lindex $args 0] htmlAttributes off
	}
}

proc contextualMenu::editTag {} {
    global alpha::CMArgs
    goto [lindex [set alpha::CMArgs] 0]
    html::EditTag
}

proc contextualMenu::followLink {} {
    global alpha::CMArgs
    goto [lindex [set alpha::CMArgs] 0]
    catch {html::FollowLink [getPos]}
}
