# Tcl package index file, version 1.1
# This file was generated by hand.
# 
# It invokes the "package ifneeded" command to set up package-related
# information so that packages will be loaded automatically in response
# to "package require" commands.  When this script is sourced, the
# variable $dir must contain the full path name of this file's
# directory.

# We don't really want to throw an error with older versions of
# Tcl, they should just ignore us.
if {[package provide Tcl] < 8.4} {
    return
}

package require Tcl 8.4
if {[info tclversion] == 8.4} {
    if {[regexp {8.4a(1|2|3|4)} [info patchlevel]]} {
	error "Tcl 8.4a5 (March 20th 2002) or newer is required"
    }
}

if {[lsearch -exact $auto_path $dir] == -1} {
    lappend auto_path $dir
}

if {[info exists tcl_platform(debug)]} {
    set file [file join $dir vfs10d[info sharedlibextension]]
} else {
    set file [file join $dir vfs10[info sharedlibextension]]
}

# Don't do anything if our shared lib doesn't exist.  This should
# help stop a crash on pre-release MacOS X.
if {![file exists $file]} {
    unset file
    return
}

package ifneeded vfs 1.0 [list load $file]
unset file

package ifneeded mk4vfs 1.0 [list source [file join $dir mk4vfs.tcl]]
